/***************************************************************************
                          colorDg.h  -  description
                             -------------------

		This class handles the Option->color dialog		     

        Version         : $Id: colorDg.h,v 1.1 1999/09/23 22:01:56 philcvs Exp $
        Begin           : Tue Sep 21 1999
        Copyright       : (C) 1999 by Philippe Fremy
        E-mail          : pfremy@chez.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef COLORDIALOG_H
#define COLORDIALOG_H


// Qt include files
#include <qdialog.h>
#include <qcolor.h>
#include <qlabel.h>

// Kde include files
#include <kcolorbtn.h>


class kmColorDg: public QDialog
{
	Q_OBJECT

	public:
	kmColorDg(QWidget * parent);
	~kmColorDg();

	protected slots:
	void addColChanged();
	void delColChanged();
	void norColChanged();
	void chgColChanged();

	void ok();
	void defaultCol();
	void cancel();
	void help();

	protected:
	virtual void resizeEvent( QResizeEvent *re );

	private: 
	QLabel *labN, *labA, *labD, *labC;

	// Color are stored in the buttons
	KColorButton *norFgColBt, *norBgColBt, *addFgColBt, *addBgColBt;
	KColorButton *delFgColBt, *delBgColBt, *chgFgColBt, *chgBgColBt;
};


#endif // COLORDIALOG_H



