/***************************************************************************
                          diffDg.h  -  description
                             -------------------

		This class handles the Option->diff Option dialog.

        Version         : $Id: diffDg.h,v 1.2 2000/05/02 22:47:56 philippe Exp $
        Begin           : Tue Sep 21 1999
        Copyright       : (C) 1999 by Philippe Fremy
        E-mail          : pfremy@chez.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIFFDG_H
#define DIFFDG_H

// Qt include files
#include <qbutton.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlayout.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>
#include <qtabdialog.h>

// Application specific include files
#include "kmconfig.h"

class kmDiffDg : public QTabDialog
{
    	Q_OBJECT

	public:
	kmDiffDg( QWidget * parent = 0 , const char * name = 0 );
	~kmDiffDg();

	public slots:
	void enableIgnoreExp();
	void enableCustomExp();
	void cancel();
	void ok();
	void help();

	private:
	QCheckBox *QCBignoreCase;
	QCheckBox *QCBignoreBlankLines;
	QCheckBox *QCBignoreSpaces;
	QCheckBox *QCBignoreAllSpaces;
	QCheckBox *QCBignoreRegExp;
	QLineEdit *QLEregExp;
	
	QRadioButton *qrb1;
	QRadioButton *qrb2;
	QRadioButton *qrb3;
	
	QCheckBox *QCBcustomize;
	QLineEdit *QLEcustomExp;
};


#endif // DIFFDG_H



