/***************************************************************************
                          kmerge.h  -  description
                             -------------------
			The main window.

        Version         : $Id: kmerge.h,v 1.7 2000/05/04 22:00:22 philippe Exp $
        Begin           : Tue Sep 21 1999
        Copyright       : (C) 1999 by Philippe Fremy
        E-mail          : pfremy@chez.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMERGE_H 
#define KMERGE_H 

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// Kde includes
#include <kapp.h>
#include <ktmainwindow.h>

// App include
#include "kmconfig.h"

// State of kmerge
enum KmState {
	KM_NoFile,
	KM_DispFile,
	KM_DispDiff,
	KM_Merge
};

// Application specific includes
class Kmerge : public KTMainWindow
{
	Q_OBJECT
public:
	Kmerge( /* QWidget * parent = 0 ,*/ const char *name = 0);
	void initVar();
	virtual ~Kmerge();

public slots:	
	void openLeft();
	void openRight();
	void quit();

	void doDiff();
	void mergeMode();
	void mergeComplete();

	void selectFont();
	void selectColors();
	void changeDiffOpt();
	void showLineNr();
	void writeConfig();

	void helpContents();    // Call KDE-Help
	void helpIndex();
	void helpAbout();       // Show About Dialog

	/** Enable/disables toolbar buttons and menu items according to 
	 * the kmerge state */
	void kmergeState( KmState st );

	/** Deduce the new kmerge state knowing that we've just loaded a file
	 */
	void fileJustLoaded();

protected:
	void initConfig();
	void initMenuBar();
	void initToolBar();
	void initStatusBar();
	KConfig *config;

	KMenuBar   *menuBar;
	QPopupMenu *filePm;
	QPopupMenu *diffPm;
	QPopupMenu *mergePm;
	QPopupMenu *optionPm;
	QPopupMenu *helpPm;

	int showLineNrId;

	KStatusBar *statusBar;

	KToolBar   *toolBar;
	
	kmWidget *kmw;
	kDiffIO *diffIO;
	kFileDiff *fileDiff;
	

private:
	QString leftFileDir;
	QString rightFileDir;
	QString mergeFileDir;

	//XXX: are these of any use ?
	QString leftFile;
	QString rightFile;
	QString mergeFile;
};

#endif // KMERGE_H 




