/***************************************************************************
                          kmwidget.h  -  description
                             -------------------
        Version         : $Id: kmwidget.h,v 1.8 2000/05/15 09:25:10 philippe Exp $
        Begin           : Tue Sep 21 1999
        Copyright       : (C) 1999 by Philippe Fremy
        E-mail          : pfremy@chez.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMWIDGET_H
#define KMWIDGET_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// Qt include files
#include <qwidget.h>
#include <qgroupbox.h>
#include <qscrollbar.h>
#include <qscrollview.h>
#include <qlabel.h>
#include <qlist.h>
#include <qmultilinedit.h>
#include <qpushbutton.h>

// Kde include files
#include <kapp.h>

// Application specific include files
class kFileDiff;
#include "ktextview.h"

/* 		       ---------------
 *			  kmWidget
 * 		       --------------- 			*/
/**
  *		The main widget
  */
class kmWidget : public QWidget
{
	Q_OBJECT
public:
	kmWidget(QWidget *parent = 0, const char *name = 0);
	virtual ~kmWidget();

	void initButtons();
	void initLayout();

	void setDiff(kFileDiff * );

	void newDispParam();
	void leftFileChanged();
	void rightFileChanged();
	void diffAvailable();

	void setMergeMode(bool on);
	bool mergeMode() { return _merging; }

public slots:
	void prevDiff();
	void nextDiff();
	void unselectDiff();

	void setY( int y );

	void leftTakeAll();
	void leftTakeOne();
	void leftEditOne();
	void rightTakeAll();
	void rightTakeOne();
	void rightEditOne();
	void bothTakeEdit();

	//void showXY(int x, int y);

signals:
	void sg_mergeComplete();

protected:
	void updateTview();	
	void takeIdentLines(int diffNb);
	void mergeComplete();
	bool saveMerge(QString filename);

	bool _merging;
	QString mergeDir;
	int curDiff;
	kFileDiff * fileDiff;

	QLabel *lTitle;
	QLabel *rTitle;
	
	//QScrollBar *sbar;
	QScrollView *lsv;
	QScrollView *rsv;
	ktextView *lTview;
	ktextView *rTview;

	QWidget *butWidget;
	QPushButton *_leftTakeAll, *_leftTakeOne, *_leftEditOne;
	QPushButton *_rightTakeAll, *_rightTakeOne, *_rightEditOne;
	QPushButton *_bothTakeEdit;
	QMultiLineEdit *qme;
};

#endif // KMWIDGET_H


