/***************************************************************************
                          ktextview.h  -  description
                             -------------------
   Version	: $Id: ktextview.h,v 1.6 2000/05/04 22:00:24 philippe Exp $
   Begin	: Tue Sep 21 1999
   Copyright	: (C) 1999 by Philippe Fremy
   E-mail	: pfremy@chez.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KTEXTVIEW_H
#define KTEXTVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// Qt include files
#include <qwidget.h>
#include <qlabel.h>
#include <qlist.h>

// Kde include files
#include <kapp.h>

// Application specific include files
#include "diffIO.h"

/**								
  *   Structure that hold information about a line to be displayed
  */								
struct kdispLine {
	int lNum;	
	DiffType type;
};


enum DispMode {
	NoDisp,
	DispFile,
 	DispDiff
};	

/* 		       ---------------
 *			  ktextView
 * 		       --------------- 			*/
/**
  *  This class contains two scrollable areas
  */
class ktextView : public QWidget
{
	Q_OBJECT
public:
	ktextView( bool _isLeft, QWidget *parent = 0, const char *name = 0);
	~ktextView();
	
	// Handling the content and the display mode (colorized or not ?)
	void setDispParam();
	void setMode( DispMode m );
	DispMode dispMode() { return mode; }

	void computeDispLines();
	void setDiff( kFileDiff * fileDiff);

	const QRect curDiffRect();
	const QRect nextDiff();
	const QRect prevDiff();
	const QRect selectDiff(int diffNb);

public slots:
	void fileChanged();
	void diffAvailable();
	
protected:
	void paintEvent( QPaintEvent * pe);

	int h2line( int h );

private:
	DispMode mode;

	QFont ft;
	int lineWidth;
	int fHeight;
	//int longestLine;
	int xOffs;

	bool isLeft;
	int curDiff;

	QStrList * strings;
	QList<kdispLine> dispLines;
	kFileDiff * fileDiff;

};

#endif // KTEXTVIEW_H








